futhark-0.25.27: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.CodeGen.Backends.GPU

Description

C code generation for GPU, in general.

This module generates codes that targets the tiny GPU API abstraction layer we define in the runtime system.

Synopsis

- gpuOperations :: Operations OpenCL ()
- gpuOptions :: [Option]
- generateGPUBoilerplate :: Text -> [(Name, KernelConstExp)] -> Text -> [Name] -> [PrimType] -> [FailureMsg] -> CompilerM OpenCL () ()

# Documentation

gpuOperations :: Operations OpenCL () Source #

gpuOptions :: [Option] Source #

Options that are common to multiple GPU-like backends.

generateGPUBoilerplate :: Text -> [(Name, KernelConstExp)] -> Text -> [Name] -> [PrimType] -> [FailureMsg] -> CompilerM OpenCL () () Source #

Called after most code has been generated to generate the bulk of the boilerplate.